About Ampricot
========

Ampricot is a full-fledged and lightweight, free and open source, easy to install and use, cross-platform web server solution stack package for professional web development.

Ampricot mainly consists of the Apache HTTP Server, MySQL Database, and the PHP Interpreter. It’s extensible and highly flexible nature allows it to support other Interpreters (ex: Perl/Python/ ..etc) and Database Servers (RDBMS/NoSQL).

Ampricot provides an excellent out-of-the-box solution for Server Management, Application Management, and Database Management.

---
> Core Components: Apache | MySQL | PHP

> Extra Components: Check out download page for full list.

> Etymology: Ampricot’s name is an compound acronym of: Apache – MySQL – PHP – Apricot

> Compatibility: Windows – XP SP3, Vista, 7, 8, Server 2003, Server 2008. Linux/MacOSX coming soon..

---

## Philosophy:##

* The philosophy behind Ampricot is to build an easy to install and use web server solution stack for developers to get into the world of web development. To make it convenient for developers Ampricot shipped pre-configured with most features turned on.

* Ampricot has been developed with OOP/MVC aspects in mind, although it’s not just one piece of software, instead it’s a solution stack, we built it up to work smoothly like it’s been invented originally by single vendor as a single piece of software. It simply works like a charm!

* While the tech world is changing around us, Ampricot aims to put the new standards of web server solution stacks, it aims to be itself the standard.

---


## Key Features: ##
1. Free and Open Source – Ampricot simply licensed under the MIT license! That’s it!
2. Lightweight/LZMA Compressor – Ampricot ‘s size is very small, and consumes very low resources.
3. Highly Organized – All Ampricot ‘s files are carefully organized, and ordered with OOP/MVC patterns in mind.
4. Up-to-date Stack/Components – Ampricot always shipped with the latest stable and up-to-date core/extra components.
5. Highly Extensible and Flexible – Ampricot supports extra components on it’s core level, with every aspect fully configurable.
6. Zero Configuration – Ampricot is shipped pre-configured with the best development environment settings, no manual configuration/maintenance required. Of course you still have the ability to completely manage and configure every piece of the software.
7. Multi Versioned Core/Extra Components – Ampricot supports multiple versions of core/extra components, for example you can install two different versions of Apache, and switch between them whenever you wish with just one click.
8. Multiple Configuration Profiles – While Ampricot supports multi versioned core/extra components, every version of every component has it’s own isolated configuration profile. Which means whenever you customize certain version’s settings, it will not affect any of the others.
9. Cross-platform and Compatibility – Ampricot supports a wide range of operating systems with as minimum requirements to launch, additionally it doesn’t require any third-party software to work.
10. Translation/i18n – Ampricot is fully localized/translated to multiple languages by default from the outer skin to the inner core, and also allows additional localizations/translations.
11. Separation of concerns – Ampricot‘s core files that should never or rarely touched, are organized together in a separate container, while those other data and configuration files that developers always keep in touch, customize and eventually change are kept in a separate container easily reached.
12. Fast Development/Time Saving – Ampricot lets you focus/concentrate more on your business and less on the infrastructure. Tracking, installing, and configuring Interpreters/RDBMS libraries and drivers is a development time sink. You should be spending your time writing code, not diagnosing environment differences among your team and between development and production. Using consistent, supported, and up-to-date web server solution stack makes your life easier.
13. Rapid Deployment – An agile development process requires an agile deployment process. Application deployment with Ampricot lets you standardize and automate your deployment, getting applications out into production faster and more reliably.
14. Silent/Unattended Installer Support – Ampricot supports silent/unattended installation besides the normal GUI. You can even include the whole package inside your application and make it installed silently in the background.
15. Intelligent Installer/Uninstaller – Ampricot‘s installer is intelligent enough to make sure that there’s only one instance running/installed. If you tried to run/launch the installer while it’s already opened, it will get your opened window in focus, instead of launching another doubled window for no reason. Also once launched, it will check for previously installed versions, if found it will offer the ability to uninstall it first before installing the new version, you’re free to accept/deny offered uninstall. Uninstaller is also intelligent enough to make sure that only core and log files are completely removed, while data and configuration files are kept in a backup folder.
16. Virtual Host Oriented – Ampricot‘s core design is virtual host oriented, which means that the default landing page of your localhost URL is itself a virtual host. Ampricot‘s document root is just a container for virtual hosts, including the default one. It doesn’t contain accessible files in it’s level directly. Accessible files are located inside virtual hosts directories. This means that all your websites will be isolated and there is no mess in your www (a.k.a public_html) folder, additionally if you have many projects in different places you can host them from where they exist even if it’s a network drive! Each virtual host has a directory structure of it’s own, and responds to it’s own request URL (ex: http://testhost/). All required local DNS bindings are managed completely automatically behind the scenes.
17. Apache Alias Supported – Ampricot fully supports Apache Alias to create custom mappings. You are free to map whatever folder in wherever place to whatever URL. Alogside with Apache Virtual Hosts, you’ve extremely powerful flexibility. The power in your hands!!

---

## Get Involved: ##

Feel free to contact us and get involved in the development. Our repositories are all publicly available on Github, you even can fork it and play with.

In case you wish to contribute non-continuously or just fix some issues, then you can send your pull request to our repository and we’ll consider it.

---

## Giveback: ##

If you fell in love with Ampricot, and would like to giveback, you can do one or more of the following:

Contribute to the project – Supply new translation – Help fixing known issues – help others solving their issues – write your positive thoughts about the product in a review and publish it – Link-back to our website – send us your feedback – spreed the word and tell your friends about Ampricot

---

## Production: ##

Ampricot is made from the ground up for developers and development environments; However it can be used in production environments as well. You may need to tweak and change few settings first to ensure security.

---

## Thanks: ##

First of all, thanks to the original core components authors, the awesome guys worked on it, and the companies behind it. Without such great pieces of software like Apache, MySQL, and PHP this product never exists.

Many thanks for the cool audience, and the whole community of Contributors, Translators, Testers, QA Specialists, Documenters, Bug Reporters, nominators, and Users. Thanks a lot for your appreciated support.

---

## License: ##

Ampricot Licensed under the MIT License (MIT)

Copyright (c) 2011-2012 FruiTechLabs

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the “Software”), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED “AS IS”, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

THIS SOFTWARE INCLUDES OTHER SOFTWARE(s) BY OTHER VENDORS, EVERY PIECE OF SUCH SOFTWARE MAY HAS IT’S OWN DIFFERENT LICENSE WHICH INCLUDED WITH IT AS WELL.
